<?php
/**
 * @file
 * A reference type plugin to describe commerce product references.
 */
$plugin = array(
  'handler' => array(
    'class' => 'reference_table_formatter_commerce_product_reference',
  )
);

class reference_table_formatter_commerce_product_reference extends reference_table_formatter_base_type {
  /**
   * {@inheritdoc}
   */
  public function get_bundles() {
    $bundles = array();
    $settings = $this->instance['settings']['referenceable_types'];
    foreach ($settings as $key => $type) {
      if ($key == $type) {
        $bundles[] = $type;
      }
    }
    return $bundles;
  }

  /**
   * {@inheritdoc}
   */
  public function entity_name() {
    return 'commerce_product';
  }

  /**
   * {@inheritdoc}
   */
  public function renderable_properties() {
    return array(
      'product_id',
      'sku',
      'commerce_price',
      'commerce_stock',
      'title',
    );
  }

  /**
   * {@inheritdoc}
   */
  function load_entity_from_item($item) {
    return array_shift(entity_load($this->entity_name(), array($item['product_id'])));
  }
}
